using System;
using System.Data;
using System.Data.SqlClient;

//ADO.NET
/* Connection - comunicaci'on con el Servidor de datos (credenciales)
 *  Command - ejecutar acciones (SELECT, INSERT, UPDATE, DELETE)
 *	Recordset - ya no existe en ADO.NET
 * 
 * DataSet (1 o m'as tablas) y establecer relaciones entre ellas
 *				sirve tanto para LECTURAS como para ESCRITURAS
 * DataReader
 *				sirve s'olo para LEER DATOS (SELECTs)
 * 
 */

namespace Biblioteca
{

	/// <summary>
	/// Clase que Prove el acceso a Datos.
	/// </summary>
	public class Datos       /*192.168.11.12*/
	{
		//conexi'on
		static SqlConnection con = new SqlConnection();
	
		//adapter
		static SqlDataAdapter da = new SqlDataAdapter();

		/// <summary>
		/// Inicializa el Conection String del objeto con
		/// </summary>
		public static void DefinirConexion()
		{

			con.ConnectionString = "data source = (local); Initial Catalog=Northwind; Integrated Security = true;";
		}

		/// <summary>
		/// dsdasddas
		/// </summary>
		/// <returns></returns>
		public static DataSet ExtraerProductos()
		{
			//comando
			SqlCommand com = new SqlCommand();

			//DataSet
			DataSet ds = new DataSet();

			DefinirConexion();

			com.CommandText = "ExtraerTodosLosProductos";
			com.CommandType = System.Data.CommandType.StoredProcedure;
			com.Connection = con;

			da.SelectCommand = com;
			//llenar DataSet
			da.Fill(ds);

			return ds;

		}

		/// <summary>
		/// Mtodo ExtraerProductos que devuelve los elementos de la tabla
		/// Products (Northwind) menores a una "condicion"
		/// </summary>
		/// <param name="condicion">De tipo Entero, define el lmite mximo</param>
		/// <returns></returns>
		public static DataSet ExtraerProductos(int condicion)
		{
			//DataSet
			DataSet ds = new DataSet();
			
			//comando
			SqlCommand com = new SqlCommand();

			DefinirConexion();
		
			com.CommandText = "ExtraerProductosMenoresA";
			com.CommandType = CommandType.StoredProcedure;
			com.Connection = con;
			com.Parameters.Add("@IdProducto", SqlDbType.Int);
			com.Parameters["@IdProducto"].Direction = ParameterDirection.Input;
			com.Parameters["@IdProducto"].Value = condicion;

			da.SelectCommand = com;

			//llenar DataSet
			da.Fill(ds);

			return ds;
		}


		/// <summary>
		/// dasdfaddas
		/// </summary>
		/// <param name="usuario"></param>
		/// <param name="password"></param>
		/// <returns></returns>
		public static bool AutenticarUsuario(string usuario, string password)
		{
			bool exito;
			SqlCommand com = new SqlCommand();
			SqlDataReader dr; //necesitamos abrir manualmente la conexion.
			DefinirConexion();
			com.Connection = con;
			com.CommandText = "AutenticarEmpleado";
			com.CommandType = CommandType.StoredProcedure;
			com.Parameters.Add("@Id", SqlDbType.NVarChar, 10);
			com.Parameters.Add("@Pwd", SqlDbType.NVarChar, 20);
			com.Parameters.Add("@NumRegistros", SqlDbType.Int);

			com.Parameters["@Id"].Direction = ParameterDirection.Input;
			com.Parameters["@Id"].Value = usuario;

			com.Parameters["@Pwd"].Value = password;
			com.Parameters["@Pwd"].Direction = ParameterDirection.Input;
			
			com.Parameters["@NumRegistros"].Direction = ParameterDirection.ReturnValue;
			
			
			//ExecuteReader - si el resultado es una tabla
			//ExecuteScalar - si el resultado es un n'umero
			//ExecuteNonQuery - si la operaci'on no retorna valores
			con.Open();
			dr = com.ExecuteReader();
			exito = dr.HasRows;
			con.Close();
			int valor_retorno = (int) com.Parameters["@NumRegistros"].Value;
			return exito;
		}
	}








}
