using System;
using System.Data;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Cliente
{
	/// <summary>
	/// Summary description for ListaDeProductos.
	/// </summary>
	public class ListaDeProductos : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnCargar;
		private System.Windows.Forms.DataGrid grdProductos;
		private System.Windows.Forms.TextBox txtCondicion;
		private System.Windows.Forms.Button btnGuardarXML;
		private System.Data.DataSet dsCliente = new System.Data.DataSet();

		const string archivoXML = @"D:\TA\Charlas\Univalle\codigo\Cliente\Productos.xml";
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ListaDeProductos()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnCargar = new System.Windows.Forms.Button();
			this.grdProductos = new System.Windows.Forms.DataGrid();
			this.txtCondicion = new System.Windows.Forms.TextBox();
			this.btnGuardarXML = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.grdProductos)).BeginInit();
			this.SuspendLayout();
			// 
			// btnCargar
			// 
			this.btnCargar.Location = new System.Drawing.Point(16, 16);
			this.btnCargar.Name = "btnCargar";
			this.btnCargar.TabIndex = 0;
			this.btnCargar.Text = "Cargar";
			this.btnCargar.Click += new System.EventHandler(this.btnCargar_Click);
			// 
			// grdProductos
			// 
			this.grdProductos.DataMember = "";
			this.grdProductos.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.grdProductos.Location = new System.Drawing.Point(16, 48);
			this.grdProductos.Name = "grdProductos";
			this.grdProductos.Size = new System.Drawing.Size(560, 200);
			this.grdProductos.TabIndex = 1;
			// 
			// txtCondicion
			// 
			this.txtCondicion.Location = new System.Drawing.Point(104, 16);
			this.txtCondicion.Name = "txtCondicion";
			this.txtCondicion.Size = new System.Drawing.Size(312, 20);
			this.txtCondicion.TabIndex = 2;
			this.txtCondicion.Text = "";
			// 
			// btnGuardarXML
			// 
			this.btnGuardarXML.Location = new System.Drawing.Point(480, 16);
			this.btnGuardarXML.Name = "btnGuardarXML";
			this.btnGuardarXML.Size = new System.Drawing.Size(96, 23);
			this.btnGuardarXML.TabIndex = 3;
			this.btnGuardarXML.Text = "Guardar XML";
			this.btnGuardarXML.Click += new System.EventHandler(this.btnGuardarXML_Click);
			// 
			// ListaDeProductos
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(608, 266);
			this.Controls.Add(this.btnGuardarXML);
			this.Controls.Add(this.txtCondicion);
			this.Controls.Add(this.grdProductos);
			this.Controls.Add(this.btnCargar);
			this.Name = "ListaDeProductos";
			this.Text = "Lista De Productos";
			((System.ComponentModel.ISupportInitialize)(this.grdProductos)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void btnCargar_Click(object sender, System.EventArgs e)
		{
			try
			{
				this.grdProductos.DataSource = null;
				
				if(System.IO.File.Exists(archivoXML))
				{
					dsCliente.ReadXml(archivoXML);
					MessageBox.Show("Se carg desde el XML");
				}
				else
				{
					dsCliente=UIP.ExtraerProductos(this.txtCondicion.Text);
					MessageBox.Show("Se carg desde la Base de Datos");
				}
				this.grdProductos.DataSource = dsCliente; 
				}
			catch(Exception ex){
				MessageBox.Show(ex.Message);
			}

		
		}

		private void btnGuardarXML_Click(object sender, System.EventArgs e)
		{
			dsCliente.WriteXml(archivoXML,XmlWriteMode.WriteSchema);
		
			MessageBox.Show("Se escribi XML correctamente!");

		}
	}
}
